# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import re
import html


def update_package():
    # Declaring local variables
    package_updated = False
    
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = get_proxies()

  
    download_url = "http://www.technosys.net/download.aspx?file=syspin.exe"
    latest_bin =  requests.head( download_url,allow_redirects=True,proxies=proxies).headers['content-disposition'].split('=')[-1]

    # Fragment HTML fourni
    html_snippet = '''
    <p id="cap"><font style="vertical-align: inherit;"><font style="vertical-align: inherit;">Épingler à la barre des tâches</font></font></p>
    <p><font style="vertical-align: inherit;"><font style="vertical-align: inherit;">Version x64&nbsp;: 0.99.9.1 Date de sortie&nbsp;: 05 déc. 2020</font></font></p><br>
    '''

    # Supprimer les balises HTML pour obtenir le texte brut
    text = re.sub('<[^<]+?>', '', html_snippet)

    # Convertir les entités HTML en caractères
    text = html.unescape(text)

    # Supprimer les espaces de début et de fin
    text = text.strip()

    # Séparer le texte en lignes
    lines = text.split('\n')

    # Initialiser la variable version
    version = None

    # Parcourir les lignes pour trouver celle qui contient "Version x64"
    for line in lines:
        if "Version x64" in line:
            # Rechercher le numéro de version dans la ligne
            match = re.search(r'Version x64\s*:\s*([\d\.]+)', line)
            if match:
                version = match.group(1)
                print(f"La version extraite est : {version}")
                break

    # Downloading latest binaries
    print("Download URL is: %s" % download_url)
    if not isfile(latest_bin):
        print("Downloading: %s" % latest_bin)
        wget(download_url, latest_bin, proxies=proxies)
        package_updated = True
    else:
        print("Binary is present: %s" % latest_bin)


    # Deleting outdated binaries
    for f in glob.glob('*.exe'):
        if f != latest_bin:
            remove_file(f)

           
    version = get_version_from_binary(latest_bin)
    # Mettre à jour le package
    control.set_software_version(version)
    control.save_control_to_wapt()    
        

